import 'dart:convert';

LoginResponse loginResponseFromJson(String str) => LoginResponse.fromJson(json.decode(str));

String loginResponseToJson(LoginResponse data) => json.encode(data.toJson());

class LoginResponse {
  LoginResponse({
    this.data,
    this.isError,
    this.errors,
  });

  Data data;
  bool isError;
  Errors errors;

  factory LoginResponse.fromJson(Map<String, dynamic> json) => LoginResponse(
    data: Data.fromJson(json["data"]),
    isError: json["is_error"],
    errors: Errors.fromJson(json["errors"]),
  );

  Map<String, dynamic> toJson() => {
    "data": data.toJson(),
    "is_error": isError,
    "errors": errors.toJson(),
  };
}

class Data {
  Data({
    this.token,
    this.slug,
    this.ts,
  });

  String token;
  String slug;
  int ts;

  factory Data.fromJson(Map<String, dynamic> json) => Data(
    token: json["token"],
    slug: json["slug"],
    ts: json["ts"],
  );

  Map<String, dynamic> toJson() => {
    "token": token,
    "slug": slug,
    "ts": ts,
  };
}

class Errors {
  Errors({
    this.ts,
  });

  int ts;

  factory Errors.fromJson(Map<String, dynamic> json) => Errors(
    ts: json["ts"],
  );

  Map<String, dynamic> toJson() => {
    "ts": ts,
  };
}
