import 'package:rs_ecommerce/Repository/repository.dart';
import 'package:rs_ecommerce/login/validators.dart';
import 'package:rxdart/rxdart.dart';
import 'AuthorizationBloc.dart';


class LoginBloc extends Validators {
  Repository repository = Repository();
  final BehaviorSubject _emailController = BehaviorSubject<String>();
  final BehaviorSubject _passwordController = BehaviorSubject<String>();
  final PublishSubject _loadingData = PublishSubject<bool>();
  Function(String) get changeEmail => _emailController.sink.add;
  Function(String) get changePassword => _passwordController.sink.add;
  Stream<String> get email => _emailController.stream.transform(_emailController.value);
  Stream<String> get password => _passwordController.stream.transform(_passwordController.value);
  Stream<bool> get submitValid => Rx.combineLatest2(email, password, (email, password) => true);
  Stream<bool> get loading => _loadingData.stream;
  void submit() {
    final validEmail = _emailController.value;
    final validPassword = _passwordController.value;
    _loadingData.sink.add(true);
    login(validEmail, validPassword);
  }
  login(String email, String password) async {
    String token = await repository.login(email, password);
    _loadingData.sink.add(false);
    authBloc.openSession(token);
  }
  void dispose() {
    _emailController.close();
    _passwordController.close();
    _loadingData.close();
  }
}

