
import 'package:flutter/material.dart';
import 'dart:convert' as convert;
import 'package:http/http.dart' as http;
import 'dart:io';
import 'package:shared_preferences/shared_preferences.dart';
import 'LoginResponse.dart';
import 'Util.dart';


class LoginPage extends StatefulWidget {
  LoginPage({Key key, this.title}) : super(key: key);

  final String title;

  @override
  _LoginPageState createState() => _LoginPageState();
}

class _LoginPageState extends State<LoginPage> {

  TextEditingController mobileController = TextEditingController();
  TextEditingController passwordController = TextEditingController();

  String _message = 'Log in/out by pressing the buttons below.';


  void _showMessage(String message) {
    setState(() {
      debugPrint("$message");
      _message = message;
    });
  }

  // facebook login




  _LoginPageState();
  Widget _backButton() {
    return InkWell(
      onTap: () {
        Navigator.pop(context);
      },
      child: Container(
        padding: EdgeInsets.symmetric(horizontal: 10),
        child: Row(
          children: <Widget>[
            Container(
              padding: EdgeInsets.only(left: 0, top: 10, bottom: 10),
              child: Icon(Icons.keyboard_arrow_left, color: Colors.black),
            ),
            Text('Back',
                style: TextStyle(fontSize: 12, fontWeight: FontWeight.w500))
          ],
        ),
      ),
    );
  }
  @override
  void initState() {
    super.initState();
  }



  var Toast;
  bool _isHidden = true;
  var hintText;

  void _toggleVisibility() {
    setState(() {
      _isHidden = !_isHidden;
    });
  }
/*  @override
  void initState(){}*/

  Widget _submitButton(BuildContext context) {
    return InkWell(
        onTap: () {
          print(mobileController.text);
          print(passwordController.text);
          LogingApi(mobileController.text,passwordController.text,context);
       //  Navigator.pushNamed(context, "/detail");  // not working Api
   //  Navigator.pushReplacement(context, MaterialPageRoute(builder: (context) => ProductAddtoCart() )); // to working daoshbordh
    },
    child: Container(
      width: MediaQuery.of(context).size.width,
      padding: EdgeInsets.symmetric(vertical: 15),
      alignment: Alignment.center,
      decoration: BoxDecoration(
          borderRadius: BorderRadius.all(Radius.circular(5)),
          boxShadow: <BoxShadow>[
            BoxShadow(
                color: Colors.grey.shade200,
                offset: Offset(2, 4),
                blurRadius: 5,
                spreadRadius: 2)
          ],
          gradient: LinearGradient(
              begin: Alignment.centerLeft,
              end: Alignment.centerRight,
              colors: [Color(0xfffbb448), Color(0xfff7892b)])
      ),
          child: Text(
          'Login',
          style: TextStyle(fontSize: 20, color: Colors.white),
      ),
    ),
    );
  }

  Widget _entryField(String title,TextEditingController cont, {bool isPassword = false}) {
    return Container(
      margin: EdgeInsets.symmetric(vertical: 10),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: <Widget>[
          Text(
            title,
            style: TextStyle(fontWeight: FontWeight.bold, fontSize: 15),
          ),
          SizedBox(
            height: 10,
          ),
          TextField(
              controller: cont,
              obscureText: isPassword,
              decoration: InputDecoration(
                  border: InputBorder.none,
                  fillColor: Color(0xfff3f3f4),
                  filled: true),
          )
        ],
      ),
    );
  }

Widget _divider() {
    return Container(
      margin: EdgeInsets.symmetric(vertical: 10),
      child: Row(
        children: <Widget>[
          SizedBox(
            width: 20,
          ),
          Expanded(
            child: Padding(
              padding: EdgeInsets.symmetric(horizontal: 10),
              child: Divider(
                thickness: 1,
              ),
            ),
          ),
          Text('or'),
          Expanded(
            child: Padding(
              padding: EdgeInsets.symmetric(horizontal: 10),
              child: Divider(
                thickness: 1,
              ),
            ),
          ),
          SizedBox(
            width: 20,
          ),
        ],
      ),
    );
  }

  Widget _facebookButton() {
    return InkWell(
      onTap: (){
      },
      child: Container(
        height: 50,
        margin: EdgeInsets.symmetric(vertical: 20),
        decoration: BoxDecoration(
          borderRadius: BorderRadius.all(Radius.circular(10)),
        ),
        child: Row(
          children: <Widget>[
            Expanded(
              flex: 1,
              child: Container(
                decoration: BoxDecoration(
                  color: Color(0xff1959a9),
                  borderRadius: BorderRadius.only(
                      bottomLeft: Radius.circular(5),
                      topLeft: Radius.circular(5)),
                ),
                alignment: Alignment.center,
                child: Text('f',
                    style: TextStyle(
                        color: Colors.white,
                        fontSize: 25,
                        fontWeight: FontWeight.w400)),
              ),
            ),
            Expanded(
              flex: 5,
              child: Container(
                decoration: BoxDecoration(
                  color: Color(0xff2872ba),
                  borderRadius: BorderRadius.only(
                      bottomRight: Radius.circular(5),
                      topRight: Radius.circular(5)),
                ),
                alignment: Alignment.center,
                child: Text('Log in with Facebook',
                    style: TextStyle(
                        color: Colors.white,
                        fontSize: 18,
                        fontWeight: FontWeight.w400)),
              ),
            ),
          ],
        ),
      ),
    );



  }

  Widget _GoogleGmailButton() {
    return InkWell(
      onTap: (){
      },
      child: Container(
        height: 50,
        margin: EdgeInsets.symmetric(vertical: 20),
        decoration: BoxDecoration(
          borderRadius: BorderRadius.all(Radius.circular(10)),
        ),
        child: Row(
          children: <Widget>[
            Expanded(
              flex: 1,
              child: Container(
                decoration: BoxDecoration(
                  color: Color(0xffC83C26), //
                  borderRadius: BorderRadius.only(
                      bottomLeft: Radius.circular(5),
                      topLeft: Radius.circular(5)),
                ),
                alignment: Alignment.center,
                child: Text('G+',
                    style: TextStyle(
                        color: Colors.white,
                        fontSize: 25,
                        fontWeight: FontWeight.w400)),
              ),
            ),
            Expanded(
              flex: 5,
              child: Container(
                decoration: BoxDecoration(
                  color: Color(0xffDF4A32),
                  borderRadius: BorderRadius.only(
                      bottomRight: Radius.circular(5),
                      topRight: Radius.circular(5)),
                ),
                alignment: Alignment.center,
                child: Text('Sign in With Google+',
                    style: TextStyle(
                        color: Colors.white,
                        fontSize: 18,
                        fontWeight: FontWeight.w400)),
              ),
            ),
          ],
        ),
      ),
    );



  }
  Widget _createAccountLabel() {
    return InkWell(
      onTap: () {

      },
      child: Container(
        margin: EdgeInsets.symmetric(vertical: 20),
        padding: EdgeInsets.all(15),
        alignment: Alignment.bottomCenter,
        child: Row(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Text(
              'Don\'t have an account ?',
              style: TextStyle(fontSize: 13, fontWeight: FontWeight.w600),
            ),
            SizedBox(
              width: 10,
            ),
            Text(
              'Register',
              style: TextStyle(
                  color: Color(0xfff79c4f),
                  fontSize: 13,
                  fontWeight: FontWeight.w600),
            ),
          ],
        ),
      ),
    );
  }

/*  Widget _title() {
    return RichText(
      textAlign: TextAlign.center,
      text: TextSpan(
          text: 'd',
          style: GoogleFonts.portLligatSans(
            textStyle: Theme.of(context).textTheme.display1,
            fontSize: 30,
            fontWeight: FontWeight.w700,
            color: Color(0xffe46b10),
          ),
          children: [
            TextSpan(
              text: 'ev',
              style: TextStyle(color: Colors.black, fontSize: 30),
            ),
            TextSpan(
              text: 'rnz',
              style: TextStyle(color: Color(0xffe46b10), fontSize: 30),
            ),
          ]),
    );
  }*/

  Widget _emailPasswordWidget() {
    return Column(
      children: <Widget>[
        _entryField("Mobile",mobileController),
        _entryField("Password",passwordController, isPassword: true),
      ],
    );
  }


  @override
  Widget build(BuildContext context) {
    final height = MediaQuery.of(context).size.height;
    return Scaffold(
        body: Container(
        height: height,
         child: Stack(
        children: <Widget>[
          /// uper colo

          Container(
            padding: EdgeInsets.symmetric(horizontal: 20),
            child: SingleChildScrollView(
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.center,
                mainAxisAlignment: MainAxisAlignment.center,
                children: <Widget>[
                  SizedBox(height: height * .2),
                 // _title(),
                  SizedBox(height: 50),
                  _emailPasswordWidget(),
                  SizedBox(
                    height: 17,
                  ),
                 // _LoginButton(),
                  SizedBox(height: 20),
                  _submitButton(context),
                  Container(
                    padding: EdgeInsets.symmetric(vertical: 10),
                    alignment: Alignment.centerRight,
                    child: FlatButton(
                      child: Text('Forgot Password ?',
                      style: TextStyle(fontSize: 14, fontWeight: FontWeight.w500)),
                      onPressed: (){

                      },
                    ),
                  ),
                  _divider(),
                  _facebookButton(),
                  _GoogleGmailButton(),
                  SizedBox(height: height * .055),
                  _createAccountLabel(),
                ],
              ),
            ),
          ),
          Positioned(top: 40, left: 0, child: _backButton()),
        ],
      ),
    //)

    ),
    );
  }




  void LogingApi(String phone, String password,BuildContext context) async {
    Map data = {'phone': phone, 'password': password,'logintype': "1"};

    Map<String, String> header={"Content-Type": "application/x-www-form-urlencoded", "Charset": "utf-8"};
    // Await the http get response, then decode the json-formatted response.
    try {
      var response = await http.post("", body: data,headers: header); //get(url);
      SharedPreferences prefs = await   SharedPreferences.getInstance();
      if (response.statusCode == 200) {
        var jsonResponse = convert.jsonDecode(response.body);

        // var itemCount = jsonResponse['totalItems'];
        /* debugPrint( "renunnn   ${jsonResponse.toString()}");
        debugPrint( "renunnn   ${response.body.toString()}");  // renu  working code*/

        LoginResponse response1=
        loginResponseFromJson(response.body.toString());

        if(response1.data != null){
          prefs.setBool("islogin",true);
          prefs.setString("tokenid", response1.data.token);
          prefs.setString("slugID", response1.data.slug);
          // utilStr="cf";
          UtilDialog().showDialogs(context,"Login Sucessfull","");
          //   login screen call karna h ya

        }
        else{
          prefs.setBool("islogin",false);
          UtilDialog().showDialogs(context,"Login failed",response1.isError.toString() );
        }
      } else {
        prefs.setBool("islogin",false);
        UtilDialog().showDialogs(context, "Sorry, something went wrong",response.body);
      }
    }  catch (e ) {

      if( e is SocketException){

        UtilDialog().showDialogs(context,e.message,"");
      }
      print(e.toString());
    }

  }
}


// https://gist.github.com/rgodlontonshaw/e3e9255c59a9b45901087b63562b23d7

